"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Protocol buffer used to parametrize an iterated local search (ILS) approach.
ILS is an iterative metaheuristic in which every iteration consists in
performing a perturbation followed by an improvement step on a reference
solution to generate a neighbor solution.
The neighbor solution is accepted as the new reference solution according
to an acceptance criterion.
The best found solution is eventually returned.
"""

import builtins
import google.protobuf.descriptor
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import ortools.constraint_solver.routing_enums_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class RuinStrategy(google.protobuf.message.Message):
    """Ruin strategies, used in perturbation based on ruin and recreate approaches."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class _Value:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _ValueEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[RuinStrategy._Value.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        UNSET: RuinStrategy._Value.ValueType  # 0
        """Unspecified value."""
        SPATIALLY_CLOSE_ROUTES_REMOVAL: RuinStrategy._Value.ValueType  # 1
        """Removes a number of spatially close routes."""

    class Value(_Value, metaclass=_ValueEnumTypeWrapper): ...
    UNSET: RuinStrategy.Value.ValueType  # 0
    """Unspecified value."""
    SPATIALLY_CLOSE_ROUTES_REMOVAL: RuinStrategy.Value.ValueType  # 1
    """Removes a number of spatially close routes."""

    def __init__(
        self,
    ) -> None: ...

global___RuinStrategy = RuinStrategy

@typing.final
class RuinRecreateParameters(google.protobuf.message.Message):
    """Parameters to configure a perturbation based on a ruin and recreate approach."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    RUIN_STRATEGY_FIELD_NUMBER: builtins.int
    RECREATE_STRATEGY_FIELD_NUMBER: builtins.int
    NUM_RUINED_ROUTES_FIELD_NUMBER: builtins.int
    ruin_strategy: global___RuinStrategy.Value.ValueType
    """Strategy defining how a reference solution is ruined."""
    recreate_strategy: ortools.constraint_solver.routing_enums_pb2.FirstSolutionStrategy.Value.ValueType
    """Strategy defining how a reference solution is recreated."""
    num_ruined_routes: builtins.int
    """Number of routes removed during a ruin application defined on routes."""
    def __init__(
        self,
        *,
        ruin_strategy: global___RuinStrategy.Value.ValueType = ...,
        recreate_strategy: ortools.constraint_solver.routing_enums_pb2.FirstSolutionStrategy.Value.ValueType = ...,
        num_ruined_routes: builtins.int = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["num_ruined_routes", b"num_ruined_routes", "recreate_strategy", b"recreate_strategy", "ruin_strategy", b"ruin_strategy"]) -> None: ...

global___RuinRecreateParameters = RuinRecreateParameters

@typing.final
class PerturbationStrategy(google.protobuf.message.Message):
    """Defines how a reference solution is perturbed."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class _Value:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _ValueEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[PerturbationStrategy._Value.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        UNSET: PerturbationStrategy._Value.ValueType  # 0
        """Unspecified value."""
        RUIN_AND_RECREATE: PerturbationStrategy._Value.ValueType  # 1
        """Performs a perturbation in a ruin and recreate fashion."""

    class Value(_Value, metaclass=_ValueEnumTypeWrapper): ...
    UNSET: PerturbationStrategy.Value.ValueType  # 0
    """Unspecified value."""
    RUIN_AND_RECREATE: PerturbationStrategy.Value.ValueType  # 1
    """Performs a perturbation in a ruin and recreate fashion."""

    def __init__(
        self,
    ) -> None: ...

global___PerturbationStrategy = PerturbationStrategy

@typing.final
class AcceptanceStrategy(google.protobuf.message.Message):
    """Determines when a neighbor solution, obtained by the application of a
    perturbation and improvement step to a reference solution, is used to
    replace the reference solution.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class _Value:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _ValueEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[AcceptanceStrategy._Value.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        UNSET: AcceptanceStrategy._Value.ValueType  # 0
        """Unspecified value."""
        GREEDY_DESCENT: AcceptanceStrategy._Value.ValueType  # 1
        """Accept only solutions that are improving with respect to the reference
        one.
        """

    class Value(_Value, metaclass=_ValueEnumTypeWrapper): ...
    UNSET: AcceptanceStrategy.Value.ValueType  # 0
    """Unspecified value."""
    GREEDY_DESCENT: AcceptanceStrategy.Value.ValueType  # 1
    """Accept only solutions that are improving with respect to the reference
    one.
    """

    def __init__(
        self,
    ) -> None: ...

global___AcceptanceStrategy = AcceptanceStrategy

@typing.final
class IteratedLocalSearchParameters(google.protobuf.message.Message):
    """Specifies the behavior of a search based on ILS."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PERTURBATION_STRATEGY_FIELD_NUMBER: builtins.int
    RUIN_RECREATE_PARAMETERS_FIELD_NUMBER: builtins.int
    IMPROVE_PERTURBED_SOLUTION_FIELD_NUMBER: builtins.int
    ACCEPTANCE_STRATEGY_FIELD_NUMBER: builtins.int
    perturbation_strategy: global___PerturbationStrategy.Value.ValueType
    """Determines how a reference solution S is perturbed to obtain a neighbor
    solution S'.
    """
    improve_perturbed_solution: builtins.bool
    """Determines whether solution S', obtained from the perturbation, should be
    optimized with a local search application.
    """
    acceptance_strategy: global___AcceptanceStrategy.Value.ValueType
    """Determines when the neighbor solution S', possibly improved if
    `improve_perturbed_solution` is true, replaces the reference solution S.
    """
    @property
    def ruin_recreate_parameters(self) -> global___RuinRecreateParameters:
        """Parameters to customize a ruin and recreate perturbation."""

    def __init__(
        self,
        *,
        perturbation_strategy: global___PerturbationStrategy.Value.ValueType = ...,
        ruin_recreate_parameters: global___RuinRecreateParameters | None = ...,
        improve_perturbed_solution: builtins.bool = ...,
        acceptance_strategy: global___AcceptanceStrategy.Value.ValueType = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["ruin_recreate_parameters", b"ruin_recreate_parameters"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["acceptance_strategy", b"acceptance_strategy", "improve_perturbed_solution", b"improve_perturbed_solution", "perturbation_strategy", b"perturbation_strategy", "ruin_recreate_parameters", b"ruin_recreate_parameters"]) -> None: ...

global___IteratedLocalSearchParameters = IteratedLocalSearchParameters
